// license:BSD-3-Clause
// copyright-holders:Curt Coder
/*********************************************************************

    formats/d80_dsk.h

    Commodore 8050 sector disk image format

*********************************************************************/

#ifndef D80_DSK_H_
#define D80_DSK_H_

#include "d64_dsk.h"

class d80_format : public d64_format {
public:
	d80_format();
	d80_format(const format *formats);

	virtual const char *name() const;
	virtual const char *description() const;
	virtual const char *extensions() const;

protected:
	const format *formats;

	virtual int get_physical_track(const format &f, int head, int track);
	virtual UINT32 get_cell_size(const format &f, int track);
	virtual int get_sectors_per_track(const format &f, int track);
	virtual int get_disk_id_offset(const format &f);
	floppy_image_format_t::desc_e* get_sector_desc(const format &f, int &current_size, int sector_count, UINT8 id1, UINT8 id2, int gap_2);

	static const format file_formats[];

	static const UINT32 d80_cell_size[];
	static const int d80_speed_zone[];
	static const int d80_sectors_per_track[];
};

extern const floppy_format_type FLOPPY_D80_FORMAT;



#endif
